var createError = require('http-errors');
var express = require('express');
var path = require('path');
var cookieParser = require('cookie-parser');
var logger = require('morgan');
var cons = require('consolidate')


var app = express();

// view engine setup
app.set('examples', path.join(__dirname, 'examples'));
app.engine('html', cons.handlebars);
app.set('view engine', 'html');

app.use(logger('dev'));
app.use(express.json());
app.use(express.urlencoded({ extended: false }));
app.use(cookieParser());
app.use('/src', express.static(path.join(__dirname, '/src')));
app.use('/lib', express.static(path.join(__dirname, '/lib')));
app.use('/build', express.static(path.join(__dirname, '/build')));
app.use('/img', express.static(path.join(__dirname, '/img')));
app.use('/origin', express.static(path.join(__dirname, '/origin')));
app.use(express.static(path.join(__dirname, 'examples')));


// catch 404 and forward to error handler
app.use(function (req, res, next) {
  next(createError(404));
});

// error handler
app.use(function (err, req, res, next) {
  // set locals, only providing error in development
  res.locals.message = err.message;
  res.locals.error = req.app.get('env') === 'development' ? err : {};

  // render the error page
  res.status(err.status || 500);
  res.render('error');
});

module.exports = app;
